package google.android.test;

import java.io.IOException;
import java.net.UnknownHostException;

import yhg.comm.client.CommClient;
import yhg.comm.client.ICommClientEvent;
import yhg.comm.message.MSGChat;
import yhg.comm.message.MSGConnectServer;
import yhg.comm.message.MSGEnterClient;
import yhg.comm.message.MSGLeaveClient;
import yhg.comm.message.Message;
import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.KeyEvent;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;

public class AndroidTest extends Activity {
	private Handler handler = new Handler(){
		public void handleMessage(android.os.Message msg){
			String str = (String)msg.obj;
			tvChatList.setText(tvChatList.getText()+"\n"+str);
		}
	};
	private EditText etChat;
	private TextView tvChatList;
	private CommClient client;
	private int number;
    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
    	etChat = (EditText)findViewById(R.id.ETChat);
    	tvChatList = (TextView)findViewById(R.id.TVChatList);
    	
    	etChat.setOnEditorActionListener(new OnEditorActionListener(){

			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
				if(event.getKeyCode() == event.KEYCODE_ENTER && v.getText().toString().length() >= 1){
					MSGChat msg = new MSGChat();
					msg.setMessage(v.getText().toString());
					
					try {
						client.send(msg);
						tvChatList.setText(tvChatList.getText()+"\n["+number+"] "+v.getText().toString());
						v.setText("");
						return true;
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				
				return false;
			}
    		
    	});
        
        try {
			client = new CommClient("125.178.228.160",1000);
			
			client.setClientEvent(new ICommClientEvent(){
				public void onReceiveMessage(Message msg) {
					switch(msg.getType()){
						case Message.type_MSGChat:
							MSGChat chat = (MSGChat)msg;
							handler.sendMessage(android.os.Message.obtain(handler, 1, chat.getMessage()));
							break;
						case Message.type_MSGEnterClient:
							MSGEnterClient enter = (MSGEnterClient)msg;
							handler.sendMessage(android.os.Message.obtain(handler, 1, "----- "+enter.getNumber()+"   ϼ̽ϴ -----"));
							break;
						case Message.type_MSGLeaveClient:
							MSGLeaveClient leave = (MSGLeaveClient)msg;
							handler.sendMessage(android.os.Message.obtain(handler, 1, "----- "+leave.getNumber()+"   ϼ̽ϴ -----"));
							break;
						case Message.type_MSGConnectServer:
							MSGConnectServer connect = (MSGConnectServer)msg;
							number = connect.getNumber();
							Log.i("onReceiveMessage",Integer.toString(number));
							break;
					}
				}

				public void onSendMessage(Message msg) {
					
				}
			});
			client.start();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
    }
}